# coding: utf-8

"""
    Billingo API v3

    This is a Billingo API v3 documentation. Our API based on REST software architectural style. API has resource-oriented URLs, accepts JSON-encoded request bodies and returns JSON-encoded responses. To use this API you have to generate a new API key on our [site](https://app.billingo.hu/api-key). After that, you can test your API key on this page.

    The version of the OpenAPI document: 3.0.14
    Contact: hello@billingo.hu
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from clientapi_billingo.models.receipt_item_data import ReceiptItemData
from clientapi_billingo.models.receipt_product_data import ReceiptProductData
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

RECEIPTINSERTITEMSINNER_ONE_OF_SCHEMAS = ["ReceiptItemData", "ReceiptProductData"]

class ReceiptInsertItemsInner(BaseModel):
    """
    ReceiptInsertItemsInner
    """
    # data type: ReceiptItemData
    oneof_schema_1_validator: Optional[ReceiptItemData] = None
    # data type: ReceiptProductData
    oneof_schema_2_validator: Optional[ReceiptProductData] = None
    actual_instance: Optional[Union[ReceiptItemData, ReceiptProductData]] = None
    one_of_schemas: Set[str] = { "ReceiptItemData", "ReceiptProductData" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ReceiptInsertItemsInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: ReceiptItemData
        if not isinstance(v, ReceiptItemData):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ReceiptItemData`")
        else:
            match += 1
        # validate data type: ReceiptProductData
        if not isinstance(v, ReceiptProductData):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ReceiptProductData`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ReceiptInsertItemsInner with oneOf schemas: ReceiptItemData, ReceiptProductData. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ReceiptInsertItemsInner with oneOf schemas: ReceiptItemData, ReceiptProductData. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into ReceiptItemData
        try:
            instance.actual_instance = ReceiptItemData.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ReceiptProductData
        try:
            instance.actual_instance = ReceiptProductData.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ReceiptInsertItemsInner with oneOf schemas: ReceiptItemData, ReceiptProductData. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ReceiptInsertItemsInner with oneOf schemas: ReceiptItemData, ReceiptProductData. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], ReceiptItemData, ReceiptProductData]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


